
		<!-- id below must match target registered in above suwp_custom_product_data_tab function -->
		<div id="suwp_custom_product_data" class="panel woocommerce_options_panel">
			<?php
			
			$extract = get_option( 'suwp_author_info' );
			$include_msg = '';
			if ( is_object( $extract ) ) {
				if( !isset($extract->error) ) {
					$include_msg = $extract->include_7;
				}
			}
			
			// get all api providers
			$lists = get_posts(
				array(
					'post_type'			=>'suwp_apisource',
					'status'			=>'publish',
					'posts_per_page'   	=> -1,
					'orderby'         	=> 'post_title',
					'order'            	=> 'ASC',
				)
			);
			
			$options_tmp = array();
			$options_tmp[] = array(
						 'None'  => __( '- None -', 'stockunlocks' ),
						 '000'  => __( 'Stand-alone Unlock', 'stockunlocks' ),
					);
			
			$options = array();
			// loop over providers
			foreach( $lists as &$list ):
				
				// create the select option for that list
				$title = get_field('suwp_sitename', $list->ID ); // $list->post_title
				
				// Check if the custom field is available.
				if ( ! empty( $title ) ) {
					
					// $title = $title . ': ' . $list->post_title;
					$options_tmp[] = array(
						 $list->ID  => __( $title, 'stockunlocks' ),
					);
				
				}
				
			endforeach;
			
			$plugin_public = new Stock_Unlocks_Public( 'stockunlocks', STOCKUNLOCKS_VERSION );
			
			$options = $plugin_public->suwp_exec_array_flatten($options_tmp, 2);
			$suwp_link = ' <a href="https://www.stockunlocks.com/product/stockunlocks-plugin-pro/" target="_blank"> Go Pro </a>';
	
			$no_yes = array();
			$no_yes = array(
							'None' => __( 'No', 'stockunlocks' ),
							'Required' => __( 'Required', 'stockunlocks' ),
							);
			
			$disabled_enabled = array();
			$disabled_enabled = array(
							'disabled' => __( 'Disabled', 'stockunlocks' ),
							'custom' => __( 'Custom', 'stockunlocks' ),
							'global' => __( 'Global', 'stockunlocks' ),
							);
			
			// Select Field
			woocommerce_wp_select( array( 
				'id'            => '_suwp_api_provider', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'API provider', 'stockunlocks' ), 
				'options'         => $options,
				'desc_tip'      => 'true',
				'description'   => __( 'Select the API Provider for this service.', 'stockunlocks' ) 
			) );
			
			// Text Field
			// 'required' was affecting non-Remote Service Products when saving
			woocommerce_wp_text_input( array( 
				'id'          => '_suwp_api_service_id', 
				'wrapper_class' => 'show_if_simple', 
				'label'       => __( 'API id', 'stockunlocks' ), 
				// 'placeholder' => '',
				'desc_tip'    => 'true',
				// 'custom_attributes' => array( 'required' => 'required' ),
				'description' => __( 'Enter the API id for this service.', 'stockunlocks' )
			) );
			
			// Text Field
			woocommerce_wp_text_input( array( 
				'id'            => '_suwp_process_time', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Estimated Delivery Time', 'stockunlocks' ), 
				'placeholder'   => '',
				'desc_tip'      => 'false',
				'description' => __( 'Enter the estimated reply time.', 'stockunlocks' ) 
			) );
			
			// Select Field
			woocommerce_wp_select( array( 
				'id'            => '_suwp_is_mep', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Is mep', 'stockunlocks' ), 
				'options'       => $no_yes,
				'desc_tip'      => 'true',
				'description'   => __( 'Does this service require an mep selection?', 'stockunlocks' ) 
			) );
			
			
			// Select Field
			woocommerce_wp_select( array( 
				'id'            => '_suwp_is_network', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Is network', 'stockunlocks' ),  
				// 'placeholder'   => '',
				'options'         => $no_yes,
				'desc_tip'      => 'true',
				'description'   => __( 'Does this service require a network selection?', 'stockunlocks' ) 
			) );
			
			// Select Field
			woocommerce_wp_select( array( 
				'id'            => '_suwp_is_model', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Is model', 'stockunlocks' ),  
				// 'placeholder'   => '',
				'options'         => $no_yes,
				'desc_tip'      => 'true',
				'description'   => __( 'Does this service require a model selection?', 'stockunlocks' ) 
			) );
			
			// Select Field
			woocommerce_wp_select( array( 
				'id'            => '_suwp_is_pin', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Is pin', 'stockunlocks' ),  
				// 'placeholder'   => '',
				'options'         => $no_yes,
				'desc_tip'      => 'true',
				'description'   => __( 'Is ths a pin type service?', 'stockunlocks' ) 
			) );
			
			// Select Field
			woocommerce_wp_select( array( 
				'id'            => '_suwp_is_rm_type', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Is RM type', 'stockunlocks' ),  
				// 'placeholder'   => '',
				'options'         => $no_yes,
				'desc_tip'      => 'true',
				'description'   => __( 'Is ths a RM type service?', 'stockunlocks' ) 
			) );
			
			// Select Field
			woocommerce_wp_select( array( 
				'id'            => '_suwp_is_kbh', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Is kbh', 'stockunlocks' ),  
				// 'placeholder'   => '',
				'options'         => $no_yes,
				'desc_tip'      => 'true',
				'description'   => __( 'Is ths a kbh type service?', 'stockunlocks' ) 
			) );
			
			// Select Field
			woocommerce_wp_select( array( 
				'id'            => '_suwp_is_reference', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Is Reference', 'stockunlocks' ),  
				// 'placeholder'   => '',
				'options'         => $no_yes,
				'desc_tip'      => 'true',
				'description'   => __( 'Is ths a reference tag type service?', 'stockunlocks' ) 
			) );
			
			// Select Field
			woocommerce_wp_select( array( 
				'id'            => '_suwp_is_service_tag', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Is Service Tag', 'stockunlocks' ),  
				// 'placeholder'   => '',
				'options'         => $no_yes,
				'desc_tip'      => 'true',
				'description'   => __( 'Is ths a service tag type service?', 'stockunlocks' ) 
			) );
			
			// Select Field
			woocommerce_wp_select( array( 
				'id'            => '_suwp_is_activation', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Is Activation', 'stockunlocks' ),  
				// 'placeholder'   => '',
				'options'         => $no_yes,
				'desc_tip'      => 'true',
				'description'   => __( 'Is ths an activation type service?', 'stockunlocks' ) 
			) );
			
			// Text Field
			woocommerce_wp_text_input( array( 
				'id'          => '_suwp_price_group_id', 
				'wrapper_class' => 'show_if_simple', 
				'label'       => __( 'Price Group id', 'stockunlocks' ), 
				'placeholder' => '',
				'desc_tip'    => 'true',
				'description' => __( 'Enter the Price Group ID for this service.', 'stockunlocks' ) 
			) );
			
			// Text Field
			woocommerce_wp_text_input( array( 
				'id'          => '_suwp_price_group_name', 
				'wrapper_class' => 'show_if_simple', 
				'label'       => __( 'Price Group Name', 'stockunlocks' ), 
				'placeholder' => '',
				'desc_tip'    => 'true',
				'description' => __( 'Enter the Price Group Name for this service.', 'stockunlocks' ) 
			) );
			
			// Number Field
			woocommerce_wp_text_input( array( 
					'id'            => '_suwp_serial_length', 
					'wrapper_class' => 'show_if_simple', 
					'label'         => __( 'Serial length', 'stockunlocks' ), 
					'placeholder'   => '', 
					'type'          => 'number', 
					'custom_attributes' => array(
							'step'  => 'any',
							'min'   => '0'
						),
					'desc_tip'      => 'true',
					'description'   => __( 'Enter the required length of the IMEI or serial number.', 'stockunlocks' ), 
			) );
			
			// Textarea
			woocommerce_wp_textarea_input( 
				array( 
					'id'          => '_suwp_not_found', 
					'label'       => __( 'Not Found Options', 'stockunlocks' ), 
					'placeholder' => '', 
					'value'       => get_post_meta( $post->ID, '_suwp_not_found', true ),
					'desc_tip'      => 'true',
					'description' => __( 'FUTURE IMPLEMENTATION: List of options when code not found, comma separated.', 'stockunlocks' ),
			) );
			
			// Textarea
			woocommerce_wp_textarea_input( 
				array( 
					'id'          => '_suwp_assigned_brand', 
					'label'       => __( 'Assigned Brand', 'stockunlocks' ), 
					'placeholder' => '', 
					'value'       => get_post_meta( $post->ID, '_suwp_assigned_brand', true ),
					'desc_tip'      => 'true',
					'description' => __( 'FUTURE IMPLEMENTATION: List of assigned brands, comma separated.', 'stockunlocks' ),
			) );
			
			// Textarea
			woocommerce_wp_textarea_input( 
				array( 
					'id'          => '_suwp_assigned_model', 
					'label'       => __( 'Assigned Model', 'stockunlocks' ), 
					'placeholder' => '', 
					'value'       => get_post_meta( $post->ID, '_suwp_assigned_model', true ),
					'desc_tip'      => 'true',
					'description' => __( 'FUTURE IMPLEMENTATION: List of assigned models, comma separated.', 'stockunlocks' ),
			) );
			
			// Textarea
			$assigned_network_provider = get_post_meta( $post->ID, '_suwp_assigned_network_provider', true );
			$assigned_network_provider_val = '';
			// Check if the custom field is available.
			if ( ! empty( $assigned_network_provider ) ) {
				$assigned_network_provider_val = $assigned_network_provider;
			}
			
			woocommerce_wp_textarea_input( 
				array( 
					'id'          => '_suwp_assigned_network_provider', 
					'label'       => __( 'Assigned Network Provider', 'stockunlocks' ), 
					'placeholder' => '', 
					'value'       => $assigned_network_provider_val,
					'desc_tip'      => 'true',
					'description' => __( 'FUTURE IMPLEMENTATION: List of assigned network providers, comma separated.', 'stockunlocks' ),
			) );
			
			
			// Checkbox
			$online_status = get_post_meta( $post->ID, '_suwp_online_status', true );
			$online_status_val = 'yes';
			// Check if the custom field is available.
			if ( ! empty( $online_status ) ) {
				$online_status_val = $online_status;
			}
			   
			woocommerce_wp_checkbox( array( 
				'id'            => '_suwp_online_status', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Online', 'stockunlocks' ),
				'value'         => $online_status_val,
				'desc_tip'      => 'true',
				'description'   => __( 'When "Online", orders may be submitted. Otherwise, this service will be displayed as "Offline”.', 'stockunlocks' ),
			) );
			
			// Textarea
			woocommerce_wp_textarea_input( 
				array( 
					'id'          => '_suwp_service_notes', 
					'label'       => __( 'Service notes', 'stockunlocks' ), 
					'placeholder' => '', 
					'value'       => get_post_meta( $post->ID, '_suwp_service_notes', true ),
					'desc_tip'      => 'true',
					'description' => __( 'Holding area for previously used service details or future ideas.', 'stockunlocks' ),
			) );
			
			// Select Field: Disabled, Custom, Global
			woocommerce_wp_select( array( 
				'id'            => '_suwp_price_adj', 
				'wrapper_class' => 'show_if_simple', 
				'label'         => __( 'Auto Adjust Price', 'stockunlocks' ), 
				'options'       => $disabled_enabled,
				'desc_tip'      => 'true',
				'description'   => __( 'Automatically adjust Regular price when supplier credit changes; Custom > based on settings below; Global > based on Plugin Options.', 'stockunlocks' ) 
			) );
			
			// Number Field
			$price_adj_custom = get_post_meta( $post->ID, '_suwp_price_adj_custom', true );
			$price_adj_custom_val = '1';
			// Check if the custom field is available.
			if ( ! empty( $price_adj_custom ) ) {
				$price_adj_custom_val = $price_adj_custom;
			}
					
			woocommerce_wp_text_input( array( 
					'id'            => '_suwp_price_adj_custom', 
					'wrapper_class' => 'show_if_simple', 
					'label'         => __( 'Custom price multiplier', 'stockunlocks' ), 
					'placeholder'   => '',
					'value'       => $price_adj_custom_val,
					'type'          => 'number', 
					'custom_attributes' => array(
							'step'  => '0.01',
							'min'   => '1'
						),
					'desc_tip'      => 'true',
					'description'   => __( 'Automatically adjust Regular price by a custom multiplier value when supplier credit changes. Only works when Custom is selected above.', 'stockunlocks' ), 
			) );
			
			// Number Field
			woocommerce_wp_text_input( array( 
					'id'            => '_suwp_service_credit', 
					'wrapper_class' => 'show_if_simple', 
					'label'         => __( 'Service credit', 'stockunlocks' ), 
					'placeholder'   => '', 
					'type'          => 'number', 
					'custom_attributes' => array(
							'step'  => '0.01',
							'min'   => '0'
						),
					'desc_tip'      => 'true',
					'description'   => __( 'The required credit for this service: From Supplier.', 'stockunlocks' ), 
			) );
		
			// Hidden field
			/**
			woocommerce_wp_hidden_input(
				array( 
					'id'    => '_hidden_field', 
					'value' => 'hidden_value'
					)
			);
			**/
			
			?>
		</div>
		<?php
