<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

function suwp_dhru_get_model_list_cron( $post_id ) {
    
    global $wpdb;
    
    $plugin_admin = new Stock_Unlocks_Admin( 'stockunlocks', STOCKUNLOCKS_VERSION );

    $apidetails = $plugin_admin->suwp_dhru_get_provider_array( $post_id );
    
    // get the api details
    $suwp_dhru_url = $apidetails['suwp_dhru_url'];
    $suwp_dhru_username = $apidetails['suwp_dhru_username'];
    $suwp_dhru_api_key = $apidetails['suwp_dhru_api_key'];
    
    include( plugin_dir_path( __FILE__ ) . 'providers/get_model_list_constants_' . $post_id . '_cron.php' );
    
    $meta_value = '_suwp_api_provider';
    
    // collect all services related to this Provider
    $suwp_services = $wpdb->get_results( $wpdb->prepare( "SELECT post_id FROM " . $wpdb->prefix. "postmeta WHERE meta_key=%s AND meta_value=%d ORDER BY post_id ASC", $meta_value, $post_id ) );
    
    // loop over the services, get the brand/models, if any
    foreach( $suwp_services as $suwp_service ):
    
        $service_post_id = $suwp_service->post_id;
        
        // get the API id for this service
        $api_service_id = get_post_meta( $service_post_id, '_suwp_api_service_id', true );
        
        include( plugin_dir_path( __FILE__ ) . 'providers/get_model_list_api_' . $post_id . '_cron.php' );
    
        // Debug on
        $api->debug = true;
        
        $reply =  array();
        $para = array();
        $para['ID'] = '';
        $reply =  array();
        $services = array();
        $flag_continue = FALSE;
        
        $para['ID'] = $api_service_id; // '212' ; NULL = GETS ALL; got from 'imeiservicelist' [SERVICEID]
        
        $request = $api->action('modellist', $para);
        
        if (is_array($request)) {
            
          $iterator = new RecursiveIteratorIterator(new RecursiveArrayIterator($request), RecursiveIteratorIterator::SELF_FIRST);
          foreach ($iterator as $key1 => $val1) {
            if ($key1 === 'LIST') {
              if (is_array($val1)) {
                foreach ($val1 as $key2 => $val2) {
                  $tmp_id = $key2;
                  if (is_array($val2)) {
                    foreach ($val2 as $key3 => $val3) {
                      if ($key3 === 'NAME') {
                        $tmp_name = $val3;
                      }
                      if ($key3 === 'MODELS') {
                        $flag_continue = TRUE;
                        if (is_array($val3)) {
                          foreach ($val3 as $key4 => $val4) {
                            if (is_array($val4)) {
                              $tmp_model_id = '';
                              $tmp_model_name = '';
                              foreach ($val4 as $key5 => $val5) {
                                if ($key5 === 'ID') {
                                  $tmp_model_id = $val5;
                                }
                                if ($key5 === 'NAME') {
                                  $tmp_model_name = $val5;
                                }
                                if ($tmp_model_name != '') {
                                  $tmp_key = $tmp_id . '-php-' . $tmp_name . '-php-' . $tmp_model_id . '-php-' . $tmp_model_name;
                                  $tmp_key_model_id_display = $tmp_model_id;
                                  $services[] = array(
                                    'ID' => $tmp_key,
                                    'BRANDID' => $tmp_id,
                                    'MODELID' => $tmp_key_model_id_display,
                                    'BRANDNAME' => $tmp_name,
                                    'MODELNAME' => $tmp_model_name,
                                  );
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
        
        $item = 0;
        
        if ( $flag_continue ) {
            
            foreach ( $services as $service ) {
              // Begin extraction at the actual model.
              if ( ( !empty( $service['ID'] ) && ( $service['ID'] != NULL ) ) ) {
                $reply[] = array(
                  'item' => $item,
                  'brand_id' => $service['BRANDID'],
                  'model_id' => $service['MODELID'],
                  'brand_name' => $service['BRANDNAME'],
                  'model_name' => $service['MODELNAME'],
                );
                ++$item;
              }
            }
            
        }
        
        $plugin_admin->suwp_dhru_create_modelbrand( $post_id, $service_post_id, $reply );
        
    endforeach; // foreach( $suwp_services as $service )
    
    return $meta_value;
}

?>
